from matplotlib.backends.backend_gtk3cairo import FigureCanvasGTK3Cairo as mpl_Canvas
from gi.repository import Gtk
from matplotlib.backends.backend_gtk3cairo import RendererGTK3Cairo as RendererCairo
from aobject.utils import debug_print

class GlancerCanvas(Gtk.DrawingArea) :
    __gsignals__ = { "draw" : "override" }

    rat = 1.

    def __init__(self, fig) :
        GObject.GObject.__init__(self)
        self._canvas = mpl_Canvas(fig)
        self._canvas.show_all()
        self.set_size_request(800, 600)
        self._canvas.mpl_connect('resize_event', lambda e :
                               self._resize_for_canvas(e.width, e.height))
        self._resize_for_canvas(*self._canvas.get_width_height())

    def _resize_for_canvas(self, w, h) :
        if w == 0 or h == 0 :
            return

        aw = self.allocation.width
        ah = self.allocation.height
        w_rat = aw/w
        h_rat = ah/h

        self.rat = max(w_rat, h_rat)
        debug_print(self.rat)

        if self.rat == 0 :
            self.rat = 1.

        self.set_size_request(self.rat*w, self.rat*h)
        self.queue_draw()

    def do_draw(self, event):
        cr = self.window.cairo_create()
        cr.rectangle ( event.area.x, event.area.y, event.area.width, event.area.height)
        cr.clip()

        canvas = self._canvas
        #w1, h1 = glancer.plotter.fig.get_size_inches()
        #w1 *= self.dpi
        #h1 *= self.dpi
        #w1, h1 = glancer.plotter.canvas.get_width_height()
        #cr.save()
        #rat = canvas.figure.dpi/float(self.dpi)
        #cr.scale(1/rat, 1/rat)
        cr.save()
        cr.scale(self.rat, self.rat)

        renderer = RendererCairo (canvas.figure.dpi)
        renderer.set_width_height (*canvas.get_width_height())
        print canvas.get_width_height()
        renderer.gc.ctx = cr
        canvas.figure.draw (renderer)

        cr.restore()
        #cr.restore()

    def draw(self, *args) :
        self._canvas.draw(*args)
        self.queue_draw()

    def mpl_connect(self, *args) :
        self._canvas.mpl_connect(*args)

    def mpl_disconnect(self, *args) :
        self._canvas.mpl_disconnect(*args)
