from ..glypher.Widget import GlyphBasicGlypher
import sys
from StringIO import StringIO
from aobject.utils import debug_print
from ..glypher.PhraseGroup import GlypherBracketedPhrase
from gi.repository import Gtk
from aobject.aobject import *
from ..glypher.Word import make_word
from ..glypher import Dynamic
from sympy.core.symbol import Symbol
from ..sources.Source import Source
import lxml.etree as ET

import Command

class Glassmaker(Gtk.Frame, AObject) :
    line_height = 35.
    default_height = 560
    default_width = 360
    can_save = True

    def get_aesthete_xml(self) :
        return self.gmg.get_xml()

    def set_aesthete_xml(self, xml) :
        #xml = ET.ElementTree(ET.fromstring(xml))
        self.gmg.set_xml(xml)

    def _do_python_view_key_press_event(self, python_view, event):
        keyname = Gdk.keyval_name(event.keyval)
        m_control = bool(event.get_state() & Gdk.ModifierType.CONTROL_MASK)
        
        if m_control and keyname=='Escape' :
            self.toggle_python_view()
            return True

        return False

    def _do_gmg_key_press_event(self, gmg, event):
        keyname = Gdk.keyval_name(event.keyval)
        m_control = bool(event.get_state() & Gdk.ModifierType.CONTROL_MASK)
        
        if m_control and keyname=='Escape' :
            self.toggle_python_view()
            return True

        ret = GlyphBasicGlypher.do_key_press_event(gmg, event)
        return ret

    def toggle_python_view(self) :
        if self.python_view.get_visible() :
            self.python_view.hide()
            self.gmg.show()
            self.gmg.grab_focus()
        else :
            py = self.gmg.main_phrase.to_string("python")
            self.python_view.get_buffer().set_text(py)
            self.python_view.show()
            self.gmg.hide()
            self.python_view.grab_focus()

    def __init__(self, env = None):
        self.gmg = GlyphBasicGlypher(env=env, evaluable=False)

        GObject.GObject.__init__(self)
        AObject.__init__(self, "Glassmaker", env, view_object=True)
        self.connect("aesthete-property-change", lambda o, p, v, a : self.queue_draw())

        self.vbox = Gtk.VBox()

        self.gmg.do_key_press_event = lambda e :\
            self._do_gmg_key_press_event(self.gmg, e)
        self.gmg.caret.shortcut_families = ("FamilyGlassmaker", "FamilyGeneral")
        self.gmg.main_phrase.move()
        self.gmg.main_phrase.set_enterable(True)
        self.gmg.main_phrase.set_attachable(True)
        self.gmg.main_phrase.line_length = self.default_width
        self.absorb_properties(self.gmg)
        self.vbox.pack_start(self.gmg, True, True, 0)

        self.python_view = Gtk.TextView()
        self.python_view.connect("key-press-event",
                                 self._do_python_view_key_press_event)
        self.vbox.pack_start(self.python_view, True, True, 0)

        sw = Gtk.ScrolledWindow()
        self.output_view = Gtk.TextView()
        sw.add(self.output_view)
        self.vbox.pack_start(sw, True, True, 0)
        self.output_view.get_buffer().set_text("OUTPUT")

        self.add(self.vbox)
        self.show_all()

        self.python_view.hide()

        self.log(1, "New Glassmaker initalized")

    def run_current(self) :
        py_code = self.gmg.main_phrase.to_string("python")

        stdout = sys.stdout
        sys.stdout = StringIO()
        Dynamic.exec_for_sympy(None, py_code)
        self.output_view.get_buffer().set_text(sys.stdout.getvalue())
        sys.stdout = stdout

    def get_method_window(self) :
        win = Gtk.VBox()
        
        run = Gtk.Button('Run')
        win.pack_start(run, False, False, 0)
        run.connect("clicked", lambda w : self.run_current())

        win.show_all()

        return win

aname_root_catalog['Glassmaker'] = Glassmaker
