from gi.repository import Gtk
from Spacer import *

def symbol(sp, c) :
    togg = Gtk.ToggleButton("BBox to Ink")
    togg.set_active(sp.get_ink())
    togg.connect("toggled", lambda tb : (\
                 sp.set_ink(tb.get_active()), \
                 sp.recalc_bbox(), \
                 tb.set_active(sp.get_ink())))
    togg.show_all()
    return togg

def space(sp, c) :
	hbox = Gtk.HBox()
	hbox.pack_start(Gtk.Label("H", True, True, 0), False)
	h_entr = Gtk.Entry()
	h_entr.set_text(str(sp.get_dims()[0]))
	h_entr.connect("activate", lambda e : sp.set_dims((float(e.get_text()), sp.get_dims()[1])))
	hbox.pack_start(h_entr, True, True, 0)
	v_entr = Gtk.Entry()
	v_entr.set_text(str(sp.get_dims()[1]))
	v_entr.connect("activate", lambda e : sp.set_dims((sp.get_dims()[0], float(e.get_text()))))
	hbox.pack_start(Gtk.Label("V", True, True, 0), False)
	hbox.pack_start(v_entr, True, True, 0)
	hbox.show_all()
	return hbox

def phrase(sp, c) :
	vbox = Gtk.VBox()
	hbox = Gtk.HBox()
	hbox.pack_start(Gtk.Label("Row", True, True, 0), False)
	row_entr = Gtk.Entry()
	row_entr.set_text('0')
	hbox.pack_start(row_entr, True, True, 0)
	hbox.pack_start(Gtk.Label("Align", True, True, 0), False)
	al_entr = Gtk.Entry()
	al_entr.set_text(sp.row_aligns[0])
	hbox.pack_start(al_entr, True, True, 0)
	vbox.pack_start(hbox, False, False, 0)
	set_row_al_butt = Gtk.Button("Set row align")
	set_row_al_butt.connect("clicked", lambda o : sp.set_row_align(int(row_entr.get_text()), al_entr.get_text()))
	vbox.pack_start(set_row_al_butt, False, False, 0)
	vbox.show_all()
	return vbox

def vertical_line(sp, c) :
    tie_to_butt = Gtk.Button("Tie to sel")
    tie_to_butt.connect("clicked",
            lambda butt : sp.set_tied_to(
                c.get_selected()[0] \
                if len(c.get_selected())>0 else \
                None))
    tie_to_butt.show_all()
    return tie_to_butt

def horizontal_line(sp, c) :
    tie_to_butt = Gtk.Button("Tie to sel")
    tie_to_butt.connect("clicked",
            lambda butt : sp.set_tied_to(
                c.get_selected()[0] \
                if len(c.get_selected())>0 else \
                None))
    tie_to_butt.show_all()
    return tie_to_butt

config_widgets = {\
	"space" : space,
	"symbol" : symbol,
	"phrase" : phrase,
    "horizontal_line" : horizontal_line,
    "vertical_line" : vertical_line
	}

def get_config_widget(ty, ent, caret) :
	return config_widgets[ty](ent, caret) if ty in config_widgets else None
