import glypher as g
from PhraseGroup import GlypherCompoundPhrase
from Phrase import GlypherPhrase
from Entity import GlypherEntity
from Spacer import GlypherSpace
import math

class GlypherOver(GlypherCompoundPhrase) :
    word_mode = False
    elevation = 0.2
    def __init__(self, parent, area=(0,0,0,0), over=None, expression=None,
                 elevation=None) :
        if elevation is not None :
            self.elevation = elevation
        GlypherCompoundPhrase.__init__(self, parent, [], area=area)
        self.mes.append('over')
        self.set_p('wordlike', True)
        phrase = GlypherPhrase(self)
        self.adopt(phrase)
        #self.append(over, row=-1)
        self.set_row_align(0, 'c')
        self.set_row_align(-1, 'c')
        self.add_target(phrase, 'expression')
        self.set_expr('expression')
        phrase.adopt(expression)
    #def child_change(self) :
    #    GlypherCompoundPhrase.child_change(self)
    #    word_mode = False
    #    if len(self['expression'])==1 :
    #        word = self['expression'].get_entities()[0]
    #        if word.am('word') :
    #            if not word.get_ink() :
    #                word.set_ink(True)
    #                word.recalc_bbox()
    #            word_mode = True
    #    #if self.word_mode != word_mode :
    #    #    self.recalc_bbox()
    #    self.word_mode = word_mode

    #def recalc_bbox(self, quiet=False, enact=True, realign=True,
    #                sub_pos_search_dir=None, compare_rows=False,
    #                in_feed_chain=False, do_reset=True) :
    #    if self.word_mode:
    #        nie = self['expression'].get_entities()[0].get_non_ink_extent()
    #        self.set_ref_width(nie[1]-nie[0])
    #        self.set_ref_height(nie[3]-nie[2])
    #        GlypherEntity.recalc_bbox(self, quiet=quiet)
    #    else :
    #        GlypherCompoundPhrase.recalc_bbox(self, quiet=quiet,
    #                                          enact=enact, realign=realign,
    #                sub_pos_search_dir=sub_pos_search_dir,
    #                compare_rows=compare_rows,
    #                in_feed_chain=in_feed_chain, do_reset=do_reset)

    #def child_bbox_changed(self, child) :
    #    if self.word_mode :
    #        self.recalc_bbox(in_feed_chain=True)
    #    else :
    #        GlypherCompoundPhrase.child_bbox_changed(self, child)

    def to_string(self, mode="string", true_mode=None) :
        return self['expression'].to_string(mode, true_mode)

class GlypherDiaeresis(GlypherOver) :
    def __init__(self, parent, area=(0,0,0,0), expression=None) :
        #diaeresis_mark = GlypherMarkDiaeresis(parent)
        GlypherOver.__init__(self, parent, area=area,
                             expression=expression)
        self.mes.append('diaeresis')
    def to_string(self, mode="string", true_mode=None) :
        return GlypherOver.to_string(self, mode, true_mode)+u'_ddot'

    def draw(self, cr) :
        GlypherOver.draw(self, cr)

        if not self.get_visible() or self.get_blank() :
            return

        bb = self.config[0].bbox
        if len(self['expression']) == 1 :
            word = self["expression"].get_entities()[0]
            if word.am('word') :
                bb = word.get_ink_extent()

        expr = self['expression']
        cr.save()
        cr.set_source_rgba(0,0,0,1.0)
        l = bb[0]
        t = bb[1]-self.elevation*self.get_scaled_font_size()
        w = bb[2]-bb[0]
        r = self.get_scaled_font_size()/10.
        cr.move_to(l+w/2-r, t)
        cr.arc(l+w/2-r, t+r/2, r/2., 0, 2*math.pi)
        cr.fill()
        cr.move_to(l+w/2+r, t)
        cr.arc(l+w/2+r, t+r/2, r/2., 0, 2*math.pi)
        cr.fill()
        cr.restore()

class GlypherMarkDot(GlypherSpace) :
    def __init__(self, parent=None) :
        GlypherSpace.__init__(self, parent, dims=(0.4,0.1),
                              as_line_height_scale=True, blank=False)
    def draw(self, cr) :
        if not self.get_visible() or self.get_blank() :
            return
        #GlypherSpace.draw(self, cr)
        cr.save()
        cr.set_source_rgba(0,0,0,1.0)
        l = self.config[0].bbox[0]+self.padding[0]
        t = self.config[0].bbox[1]+self.padding[1]
        w = self.get_ref_width() - self.padding[2]
        h = self.get_ref_height() - self.padding[3]
        cr.move_to(l+w/2, t)
        cr.arc(l+w/2, t+h/2, h/2, 0, 2*math.pi)
        cr.fill()
        cr.restore()

class GlypherDotDiacritic(GlypherOver) :
    def __init__(self, parent, area=(0,0,0,0), expression=None) :
        diaeresis_mark = GlypherMarkDot(parent)
        GlypherOver.__init__(self, parent, area=area, over=diaeresis_mark,
                             expression=expression)
        self.mes.append('dot_diacritic')
    def to_string(self, mode="string", true_mode=None) :
        return GlypherOver.to_string(self, mode, true_mode)+u'_dot'

g.add_phrasegroup_by_class('diaeresis', GlypherDiaeresis)
g.add_phrasegroup_by_class('dot_diacritic', GlypherDotDiacritic)
