from ..glypher.Widget import GlyphBasicGlypher, GlyphEntry
import sys
from StringIO import StringIO
from aobject.utils import debug_print
from ..glypher.PhraseGroup import GlypherBracketedPhrase
from gi.repository import Gtk
from aobject.aobject import *
from ..glypher.Word import make_word
from ..glypher import Dynamic
from sympy.core.symbol import Symbol
from ..sources.Source import Source
import lxml.etree as ET

from Sheet import Sheet

class Gridder(Gtk.Frame, AObject) :
    line_height = 35.
    default_height = 560
    default_width = 360
    suspend_activate = False
    current_cell = None

    def _do_gmg_key_press_event(self, gmg, event):
        keyname = Gdk.keyval_name(event.keyval)
        m_control = bool(event.get_state() & Gdk.ModifierType.CONTROL_MASK)
        
        ret = GlyphBasicGlypher.do_key_press_event(gmg, event)
        return ret

    def __init__(self, env = None):
        GObject.GObject.__init__(self)
        AObject.__init__(self, "Gridder", env, view_object=True)
        self.connect("aesthete-property-change", lambda o, p, v, a : self.queue_draw())


        vbox = Gtk.VBox()
        self.sheet = Sheet(20, 10)
        self.sheet.connect("activate-cell", lambda sheet, r, c :
                           self.do_sheet_activate_signal(r, c))
        sheet_scrw = Gtk.ScrolledWindow()
        sheet_scrw.add_with_viewport(self.sheet)
        vbox.pack_start(sheet_scrw, True, True, 0)

        self.cell_editor = GlyphEntry(evaluable=True)
        self.cell_editor.main_phrase.set_p('spreadsheet', self)
        self.cell_editor.connect("processed-line",
                                 self.do_cell_editor_processed_line)
        
        vbox.pack_start(self.cell_editor, False)
        vbox.show_all()

        self.add(vbox)

        self.show_all()

        self.log(1, "New Gridder initalized")

    def get_sympy_val(self, r, c) :
        if (r,c) in self.sheet.entries :
            return self.sheet.entries[(r,c)].get_sympy()
        return None

    def do_sheet_activate_signal(self, r, c) :
        if self.suspend_activate :
            return

        if self.current_cell is not None :
            self.do_cell_editor_processed_line(self.cell_editor)

        self.current_cell = (r,c)

        entry = self.sheet.entries[(r,c)]
        debug_print(entry.get_text())
        self.cell_editor.set_xml(entry.get_xml(input_phrase=True))
        self.cell_editor.grab_focus()

    def do_cell_editor_processed_line(self, ce) :
        debug_print(ce.get_xml())
        debug_print(self.current_cell)
        if self.current_cell is None :
            return

        responder = self.sheet.entries[self.current_cell]
        debug_print(responder.cell)
        xml = ce.get_xml()
        responder.set_xml(xml)

aname_root_catalog['Gridder'] = Gridder
