from gi.repository import Gtk
from ..glypher.Widget import GlyphResponder
from ..glypher.Word import make_word
from gi.repository import GObject

class Border(Gtk.DrawingArea) :
    __gsignals__ =     { \
                "draw" : "override", \
    }
    def __init__(self):
        GObject.GObject.__init__(self)

    def do_draw(self, cr) :
        #cr = self.window.cairo_create()
        #cr.rectangle ( event.area.x, event.area.y, event.area.width, event.area.height)
        #cr.clip()
        self.draw_border(cr)

    def draw_border(self, cr) :
        cr.set_source_rgb(.5, .7, .9)
        cr.paint()

class HBorder(Border) :
    def __init__(self) :
        Border.__init__(self)
        self.set_size_request(-1, 3)
class JBorder(Border) :
    def __init__(self) :
        Border.__init__(self)
        self.set_size_request(3, 3)
class VBorder(Border) :
    def __init__(self) :
        Border.__init__(self)
        self.set_size_request(3, -1)

class Sheet (Gtk.Table) :
    __gsignals__ =     {
                "activate-cell" : (GObject.SignalFlags.RUN_LAST, None,
                                     (GObject.TYPE_INT, GObject.TYPE_INT)),
                        }
    def __init__(self, r, c) :
        GObject.GObject.__init__(self, 2*r, 2*c)
        self.set_property("can-focus", True)
        self.add_events(Gdk.EventMask.BUTTON_PRESS_MASK)

        self.modify_bg(Gtk.StateType.NORMAL, Gdk.Color('black'))

        self.entries = {}
        for i in range(0, r)  :
            for j in range(0, c) : 
                test_entry = GlyphResponder(interactive=False,
                                            resize_to_main_phrase=True, evalf=True)
                test_entry.response_phrase.set_anchor_point((5, 5))
                test_entry.response_phrase.set_anchor(('l', 't'))
                #test_entry.swap()
                test_entry.response_phrase.set_p('spreadsheet', self)
                test_entry.input_phrase.set_p('spreadsheet', self)
                test_entry.show_all()
                test_entry.set_font_size(15.0)
                test_entry.connect_after("button-press-event", self.make_conn(i,j))
                test_entry.cell = (i,j)
                self.attach(test_entry, j*2, 2*(j+1), 2*i, 2*(i+1))
                self.attach(VBorder(), j*2+1, 2*(j+1)+1, 2*i, 2*(i+1), False, Gtk.AttachOptions.FILL)
                self.attach(HBorder(), j*2, 2*(j+1), 2*i+1, 2*(i+1)+1, Gtk.AttachOptions.FILL, False)
                self.attach(JBorder(), j*2+1, 2*(j+1)+1, 2*i+1, 2*(i+1)+1, False, False)
                self.entries[(i,j)] = test_entry

    def make_conn(self, i, j) :
        return lambda but, ev : self.emit('activate-cell', i, j)
