from aobject import aobject, paths
from aobject.utils import *
from gi.repository import Gtk, WebKit

signals = aobject.asignals.copy()

class AestheteHome(Gtk.ScrolledWindow, aobject.AObject) :
    def get_auto_aesthete_properties(self) :
        return {}

    __gsignals__ = signals

    def __init__(self, env) :
        Gtk.ScrolledWindow.__init__(self)
        location = paths.get_share_location()+'html/home/home.html'
        self.webview = AestheteHomeView(location, env)
        aobject.AObject.__init__(self, "Home", env=env, view_object=True)
        self.webview.load_uri('file://'+location)
        self.add(self.webview)
        self.show_all()

class AestheteHomeView(WebKit.WebView) :
    __gsignals__ = {
                "navigation-policy-decision-requested" : "override",
                }

    def do_navigation_policy_decision_requested(self, frame, request,
                                                nav_action, pol_dec) :
        uri = request.get_uri()
        debug_print(uri)
        if uri.startswith('aesthete:') :
            arr, args = translate_aobject_web_request('aesthete', uri)

            debug_print('Loading %s' % arr[1])
            debug_print(aobject.aname_root_catalog)
            obj = aobject.aname_root_catalog[arr[1]](env=self.env)

            pol_dec.ignore()
            return 1
        return 0

    def __init__(self, location, env) :
        WebKit.WebView.__init__(self)
        self.env = env
