from gi.repository import Gtk
import uuid
from aobject.utils import *
from gi.repository import Pango
from gi.repository import GObject
from .. import glypher
import copy
from lxml import etree
import cairo
from aobject import aobject
from aobject.paths import *
from ..tablemaker import *

import StringIO

def render_stock(style, stockid) :
    icon_set = style.lookup_icon_set(stockid)
    pixbuf = icon_set.render_icon(style,
                                  Gtk.TextDirection.NONE,
                                  Gtk.StateType.NORMAL,
                                  Gtk.IconSize.SMALL_TOOLBAR,
                                  None,
                                  None)
    return pixbuf

class LanternWidget(aobject.AObject) :
    x = 0
    y = 0
    h = 0
    w = 0
    design_widget = None
    presentation_widget = None
    __gsignals__ = {
         "redraw-request" : (GObject.SignalFlags.RUN_LAST, None, () )}
    current_scaling = 1.
    attached = False
    suspend = False
    visible = True
    container = False

    initial_spronk_fns = None
    initial_hide = False

    def get_auto_aesthete_properties(self) :
        return {
            'js_id' : (str,), 'x' : (float,), 'y' : (float,), 'h' : (float,), 'w' : (float,),
                }

    def change_js_id(self, var) :
        self.slide._update_ids(self.get_js_id(), var)
        self.js_id = var

    def get_unloader_js(self) :
        return \
    "document.getElementById('%s').parentNode.removeChild(document.getElementById('%s'))" % (self.get_js_id(), self.get_js_id())

    def aes_get_parameters(self) :
        return { 'on_slide' : self.slide.num, 'line' : self.slide.lines.index(self.line) }

    def initial_spronk(self) :
        if self.initial_hide :
            self.hide()
        for fn in self.initial_spronk_fns :
            fn()

    def dim(self) :
        if self.attached :
            self.layout.execute_script("document.getElementById('%s').style.visibility = 'hidden'"%\
                    self.get_js_id())
            self.visible = True

    def show(self) :
        if self.attached :
            self.layout.execute_script("document.getElementById('%s').style.visibility = 'hidden'"%\
                    self.get_js_id())
            self.visible = True

    def hide(self) :
        if self.attached :
            self.layout.execute_script("document.getElementById('%s').style.visibility = 'visible'"%\
                    self.get_js_id())
            self.visible = False

    def get_visible(self) :
        return self.visible

    def restore_to_layouts(self, n) :
        pass

    def remove_from_layouts(self) :
        pass

        #def remove_from_layouts(self) :
        #    if not self.attached :
        #        return
        #    self.attached = False
        #    for i in (0,1) :
        #        self.layouts[i].remove(self.subwidgets[i])

    def grab_focus(self) :
        if self.attached:
            self.layout.execute_script("document.getElementById('%s').focus()"%\
                                  self.get_js_id())
        #def restore_to_layouts(self) :
        #    if self.attached :
        #        return
        #    for i in (0,1) :
        #        to_pos = map(int, self.layouts[i].translate_body_pos(self.x,
        #                                                             self.y))
        #        self.layouts[i].put(self.subwidgets[i], *to_pos)
        #    self.attached = True

    def __init__(self, slide, design_layout, name_root='LanternWidget', env=None) :
        self.slide = slide
        self.layout = design_layout
        self.initial_spronk_fns = []
        aobject.AObject.__init__(self, name_root=name_root,
                                 env=env,
                                 view_object=False,
                                 elevate=False)
        self.set_js_id(self.get_aname()+'_'+str(uuid.uuid4()))

GLOSSER_WIDGET_PRESENTATION = 0
GLOSSER_WIDGET_DESIGN = 1
