from gi.repository import Gtk
import re
from aobject.utils import *
from gi.repository import Pango
from gi.repository import GObject
from .. import glypher
import copy
from lxml import etree
import cairo
from aobject import aobject
from aobject.paths import *
from ..tablemaker import *

import StringIO

from LanternWidget import *

class LanternSVG(LanternWidget) :
    ty = 'svg'
    initial_font_size = 25
    svg = '<p>Text here...</p>'

    def get_auto_aesthete_properties(self) :
        d = LanternWidget.get_auto_aesthete_properties(self)
        d.update({'svg' : (str,), 'font' : (str,)})
        return d

    def get_font(self) :
        return self.font_desc.to_string()

    def restore_to_layouts(self, n) :
        if not self.attached :
            self.layout.execute_script("add_design_svg_object('%s', %d)" %\
                                       (self.get_js_id(), n))
            self._svg_to_layout(self.get_svg())
        self.attached = True

    def change_svg(self, svg) :
        self.svg = svg
        if self.attached :
            self._svg_to_layout(svg)

    # n is available as a js var
    def get_loader_js(self) :
        svg = self.get_svg()
        svg = re.sub(r'\\', r'\\\\', svg)
        svg = re.sub(r'\n', r'\\n', svg)
        svg = re.sub(r'\t', r'\\t', svg)
        svg = re.sub(r'"', r'\\"', svg)
        name = self.get_js_id()
        js = '''
        add_presentation_svg_object('%s', n);
        fill_html('%s-div', "%s");
        ''' % (name, name, svg)
        return js

    def _svg_to_layout(self, svg) :
        svg = self.get_svg()
        svg = re.sub(r'\\', r'\\\\', svg)
        svg = re.sub(r'\n', r'\\n', svg)
        svg = re.sub(r'\t', r'\\t', svg)
        svg = re.sub(r'"', r'\\"', svg)
        self.layout.execute_script('fill_html("%s-div", "%s")' % \
                                   (self.get_js_id(), svg))
        #self.layout.execute_script("document.getElementById('%s-svg').value='%s'" % \
        #                           (self.get_aname(), self.get_svg()))
        #self.layout.execute_script("document.getElementById('%s-svg').onchange()" % \
        #                           (self.get_aname()))

    def remove_from_layouts(self) :
        if self.attached :
            self.layout.execute_script("remove_by_id('%s')"%\
                    self.get_js_id())
        self.attached = False

    def make_action_panel(self) :
        svg_table_maker = PreferencesTableMaker()
        svg_table_maker.append_row("Font",
            self.aes_method_font_button('font'))

        win = svg_table_maker.make_table()
        win.aes_title = "Glancer View"
        win.show_all()

        return win

    def change_font(self, val) :
        self.font_desc = Pango.FontDescription(val)
        self.presentation_widget.font_desc = self.font_desc

    def __init__(self, slide, design_layout, env=None) :
        self.font_desc = Pango.FontDescription(\
            "Linux Libertine %d"%int(self.initial_font_size))
        LanternWidget.__init__(self,
                               slide,
                               design_layout,
                               name_root='LanternSVG',
                                 env=env)
        self.action_panel = self.make_action_panel()
