from gi.repository import Gtk
import re
from aobject.utils import *
from gi.repository import Pango
from gi.repository import GObject
from .. import glypher
import copy
from lxml import etree
import cairo
from aobject import aobject
from aobject.paths import *
from ..tablemaker import *

import StringIO

from LanternWidget import *

class LanternTextView(LanternWidget) :
    ty = 'textview'
    initial_font_size = 25
    text = '<p>Text here...</p>'

    def get_auto_aesthete_properties(self) :
        d = LanternWidget.get_auto_aesthete_properties(self)
        d.update({'text' : (str,), 'font' : (str,)})
        return d

    def get_font(self) :
        return self.font_desc.to_string()

    def restore_to_layouts(self, n) :
        if not self.attached :
            self.layout.execute_script("add_design_textview('%s', %d)" %\
                                       (self.get_js_id(), n))
            self._text_to_layout(self.get_text())
        self.attached = True

    def change_text(self, text) :
        self.text = text
        if self.attached :
            self._text_to_layout(text)

    # n is available as a js var
    def get_loader_js(self) :
        text = self.get_text()
        text = re.sub(r'\\', r'\\\\', text)
        name = self.get_js_id()
        js = """
        add_presentation_textview('%s', n);
        console.log('1');
        fill_html('%s-div', '%s');
        """ % (name, name, text)
        return js

    def _text_to_layout(self, text) :
        text = self.get_text()
        text = re.sub(r'\\', r'\\\\', text)
        self.layout.execute_script("fill_html('%s-div', '%s')" % \
                                   (self.get_js_id(), text))
        #self.layout.execute_script("document.getElementById('%s-text').value='%s'" % \
        #                           (self.get_aname(), self.get_text()))
        #self.layout.execute_script("document.getElementById('%s-text').onchange()" % \
        #                           (self.get_aname()))

    def remove_from_layouts(self) :
        if self.attached :
            self.layout.execute_script("remove_by_id('%s')"%\
                    self.get_js_id())
        self.attached = False

    def make_action_panel(self) :
        textview_table_maker = PreferencesTableMaker()
        textview_table_maker.append_row("Font",
            self.aes_method_font_button('font'))

        win = textview_table_maker.make_table()
        win.aes_title = "Glancer View"
        win.show_all()

        return win

    def change_font(self, val) :
        self.font_desc = Pango.FontDescription(val)
        self.presentation_widget.font_desc = self.font_desc

    def __init__(self, slide, design_layout, env=None) :
        self.font_desc = Pango.FontDescription(\
            "Linux Libertine %d"%int(self.initial_font_size))
        LanternWidget.__init__(self,
                               slide,
                               design_layout,
                               name_root='LanternTextView',
                                 env=env)
        self.action_panel = self.make_action_panel()
