%define name aesthete
%define version 0.4 
%define unmangled_version 0.4
%define release 1

Summary: Markov Chain Monte Carlo sampling toolkit.
Name: %{name}
Version: %{version}
Release: %{release}
Source0: %{name}-%{unmangled_version}.tar.xz
License: GNU GPL v3
Group: Scientific
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Prefix: %{_prefix}
Vendor: Aesthete Team 
Url: launchpad.net/aesthete

Requires: numpy >= 1.4.1
Requires: python >= 2.5.0
Requires: scipy >= 0.7.2
Requires: sympy >= 0.7.1
Requires: pycairo >= 1.8.8
Requires: pygobject2 >= 2.21.5
Requires: pygtk2 >= 2.17.0
Requires: python-imaging >= 1.1.7
Requires: python-matplotlib >= 1.0.1
Requires: ipython >= 0.10
Requires: linux-libertine-fonts


BuildRequires: numpy >= 1.4.1
BuildRequires: python >= 2.5.0
BuildRequires: scipy >= 0.7.2
BuildRequires: sympy >= 0.7.1
BuildRequires: pycairo-devel >= 1.8.8
BuildRequires: pygobject2-devel >= 2.21.5
BuildRequires: pygtk2-devel >= 2.17.0
BuildRequires: python-imaging >= 1.1.7
BuildRequires: python-matplotlib >= 1.0.1
BuildRequires: ipython >= 0.10
BuildRequires: linux-libertine-fonts

%description

At its core, Aesthete is an attempt to provide a Python-based fully-featured, innovative integrated mathematical environment, as a frontend to sympy, scipy and numpy. Further, support for FEniCS is intended to provide a GUI-based finite element development environment, through tailored support for DOLFIN's Python libraries and UFL.

%prep
%setup -n %{name}-%{unmangled_version}

%build
env CFLAGS="$RPM_OPT_FLAGS" python setup.py build

%install
python setup.py install --root=$RPM_BUILD_ROOT --record=INSTALLED_FILES

%clean
rm -rf $RPM_BUILD_ROOT

%files -f INSTALLED_FILES
%defattr(-,root,root)
/usr/share/icons/hicolor/icon-theme.cache
