function add_design_video_object(id, filename, n) {
  video = add_video_object(id, filename, n);
  imdiv = video.parentNode;
  div = imdiv.parentNode;
  $(video).one('loadeddata', function() {
	  $(imdiv).width(video.videoWidth);
	  $(imdiv).height(video.videoHeight);

	  console.log(video.videoHeight);
	  $(imdiv).resizable({
		  minWidth : 10,
	          minHeight : 10,
	          stop: function(event, ui) {
	        	  send_to_lantern('property:'+id+':size:('+ui.size.width+','+ui.size.height+')');
	          }
	  });
      	  $(imdiv).draggable({
		  stop: function(event, ui) {
			  send_to_lantern('property:'+id+':offset:('+ui.position.left+','+ui.position.top+')');
		  }
	  });
  });

  $(div).on('click', function() { select_active(n); });
    div.onfocus = function() {
	    if (focused) focused.onblur();
	    focused=this;
	    this.style.background = '#99CCFF';
    	};
    div.onblur = function() {
	    this.style.background = 'none';
	    focused = null;
    	};
	div.make_active = function () {
		this.onfocus();
	};
}

function add_design_image_object(id, filename, n) {
  image = add_image_object(id, filename, n);
  imdiv = image.parentNode;
  div = imdiv.parentNode;
  $(image).load(function() {
	  $(image).resizable({
	          stop: function(event, ui) {
	        	  send_to_lantern('property:'+id+':size:('+ui.size.width+','+ui.size.height+')');
	          }
	  });
      	  $(imdiv).draggable({
		  stop: function(event, ui) {
			  send_to_lantern('property:'+id+':offset:('+ui.position.left+','+ui.position.top+')');
		  }
	  });
  });

  $(div).on('click', function() { select_active(n); });
    div.onfocus = function() {
	    if (focused) focused.onblur();
	    focused=this;
	    this.style.background = '#99CCFF';
    	};
    div.onblur = function() {
	    this.style.background = 'none';
	    focused = null;
    	};
	div.make_active = function () {
		this.onfocus();
	};
}

function add_svg(variant, svg, body_left, body_top, body_width, body_height, body_style) {
	bg = document.getElementById('background');
	bg.innerHTML = svg;
	fg = document.getElementById('foreground');
        document.getElementById('slots').style.cssText = body_style;
	fg.style.top = body_top;//-document.getElementById('background').height;
	fg.style.left = body_left;
	fg.style.width = body_width;
	fg.style.height = body_height;
}
function set_svg(variant) {
	// Nothing happens because this was done immediately with add_svg
}
function update()
{
    _set_active_slot(undefined);
    MathJax.Hub.Queue(["Typeset", MathJax.Hub]);
    if (window["SyntaxHighlighter"] !== undefined)
      SyntaxHighlighter.highlight();
    send_to_lantern('update');
}

function send_to_lantern(string) {
	document.location.href = 'lantern:'+string;
}

function set_svg(svg_text) {
	svg = document.getElementById('background');
	svg.innerHTML = svg_text;
}

function text_to_title(id) {
        el = document.getElementById(id);

	text = '';
	if (el !== null)
	   text = el.childNodes[0].data;
	else 
	   text = "{NULL}";
	document.title = text;
}

function get_value(id) {
        el = document.getElementById(id);

	text = '';
	if (el !== null)
	   text = el.value;
	else 
	   text = "{NULL}";
	document.title = text;
}

function remove_by_id(id) {
	obj = document.getElementById(id);
	if (obj !== null)
		obj.parentNode.removeChild(obj);
}

function select_active(n) {
    send_to_lantern('active:'+n);
}
function clear_all() {
	remove_mce();
	if (focused) { focused.onblur() }
}
function add_design_codeview(id, n) {
	var tv = add_codeview(id, n);
	div = tv.parentNode;
    	div.onfocus = function() {
    	        if (focused) focused.onblur();
    	        focused=this;
    	        this.style.background = '#99CCFF';
    		};
    	div.onblur = function() {
    	        this.style.background = 'none';
    	        focused = null;
    		};
	tv.saved_code = '';
	tv.onclick = function() { select_active(n); }
	div.make_active = function () {
		add_mce(this.id, 'code', 'mceCode');
		this.onfocus();
		if (tinyMCE.get('mce-textarea') !== undefined) {
			var saved_code = this.firstChild.saved_code;
			saved_code = saved_code.replace(/ /gi, "&nbsp;");
			saved_code = saved_code.replace(/\n/gi, '<br />');
			tinyMCE.get('mce-textarea').setContent(saved_code);
		}
	};
}

function add_design_svg_object(id, n) {
	var tv = add_svg_object(id, n);
	div = tv.parentNode;
    	div.onfocus = function() {
    	        if (focused) focused.onblur();
    	        focused=this;
    	        this.style.background = '#99CCFF';
    		};
    	div.onblur = function() {
    	        this.style.background = 'none';
    	        focused = null;
    		};
	tv.saved_html = '';
	tv.onclick = function() { select_active(n); }
	div.make_active = function () { this.onfocus(); };
}

function add_design_textview(id, n) {
	var tv = add_textview(id, n);
	div = tv.parentNode;
    	div.onfocus = function() {
    	        if (focused) focused.onblur();
    	        focused=this;
    	        this.style.background = '#99CCFF';
    		};
    	div.onblur = function() {
    	        this.style.background = 'none';
    	        focused = null;
    		};
	tv.saved_html = '';
	tv.onclick = function() { select_active(n); }
	div.make_active = function () { add_mce(this.id, 'text', 'mceText'); this.onfocus(); if (tinyMCE.get('mce-textarea') !== undefined) tinyMCE.get('mce-textarea').setContent(this.firstChild.saved_html); };
}

var mce;
function init_mce() {
	if (mce !== undefined)
		return;

	mce = document.createElement('form');
	mce._submit = mce.submit
	mce.submit = function () { /*mce['mce_textarea'].value = mce['mce_textarea'].value.replace(/\n/gi, '<br />');*/ mce._submit(); }
	mce.method = 'GET';
	mce.action = 'lantern:function:mce_save';

	mce_textarea = document.createElement('textarea');
	mce_textarea.id = 'mce-textarea';
	mce_textarea.name = 'mce_textarea';
	mce_textarea.rows = 15;
	mce_textarea.cols = 50;
	mce.appendChild(mce_textarea);

	mce_property_field = document.createElement('input');
	mce_property_field.type = 'hidden';
	mce_property_field.name = 'mce_property';
	mce.appendChild(mce_property_field);

	mce_id_field = document.createElement('input');
	mce_id_field.type = 'hidden';
	mce_id_field.name = 'mce_id';
	mce.appendChild(mce_id_field);
}

function _compound_offset_left(obj) {
	if (!obj)
		return 0;
	return obj.offsetLeft + _compound_offset_left(obj.offsetParent);
}

function _compound_offset_top(obj) {
	if (!obj)
		return 0;
	return obj.offsetTop + _compound_offset_top(obj.offsetParent);
}

function add_mce(id, prop, editor_type) {
	remove_mce();
	il = document.getElementById('interaction-layer');
	il.style.display = 'block';
	il.appendChild(mce);
	tinyMCE.init(mce_settings[editor_type]);
	tinyMCE.execCommand('mceAddControl', false, 'mce-textarea');
	mce['mce_id'].value = id;
	mce['mce_property'].value = prop;
	obj = document.getElementById(id);
	il.style.left = _compound_offset_left(obj)+obj.offsetLeft+.5*obj.offsetWidth;
	il.style.top = _compound_offset_top(obj)+obj.offsetHeight;
}

function remove_mce() {
	document.getElementById('interaction-layer').style.display = 'none';
	if (mce !== undefined && mce.parentNode !== null)
	{
		tinyMCE.execCommand('mceFocus', false, 'mce-textarea');
		tinyMCE.execCommand('mceRemoveControl', false, 'mce-textarea');
		mce.parentNode.removeChild(mce);
	}
}

active_slot_n = null
function reset_slide()
{
	slots.innerHTML = "";
	_set_active_slot(undefined);
}

function get_N()
{
	slots = document.getElementById('slots');
	return slots.childNodes.length;
}

var mce_settings = {};
function init_design() {
	mce_settings['mceText'] = {
		plugins : "save",
		theme_advanced_buttons3_add : "save,forecolor",
		theme : 'advanced',
		mode : 'none',
	};
	mce_settings['mceCode'] = {
		apply_source_formatting : false,
		convert_newlines_to_brs : true,
		nowrap : true,
		plugins : "save, paste",
		paste_auto_cleanup_on_paste : true,
		paste_remove_spans: true,
		paste_remove_styles: true,
		paste_retain_style_properties: false,
		paste_preprocess : function(pl, o) {
			o.content = '<pre>'+o.content+'</pre>';
		},
		remove_linebreaks : false,
		theme_advanced_buttons1 : "save",
		theme_advanced_buttons2 : "",
		theme_advanced_buttons3 : "",
		mode : 'none',
		theme : 'advanced',
		preformatted : true,
		force_br_newlines : true,
		forced_root_block : false,
		valid_elements : "",

	};
	init_mce();
}

function _set_active_slot(n) {
	if ( active_slot_n == n )
		return;
	if ( n !== null )
		active_slot_n = n;
	indicator = document.getElementById('slot-indicator');
	clear_all();
	if ( n === undefined ) {
		indicator.style.visibility = 'hidden';
	} else {
		n = active_slot_n;
		slots = document.getElementById('slots');
		if (n < 0) {
			indicator.innerHTML = '&#x2745';
			indicator.style.left = _compound_offset_left(slots)-indicator.offsetWidth;
			indicator.style.top = _compound_offset_top(slots)-slots.offsetHeight;
		} else if (n >= get_N()) {
			indicator.innerHTML = '&#x2745';
			indicator.style.left = _compound_offset_left(slots)-indicator.offsetWidth;
			indicator.style.top = _compound_offset_top(slots)+slots.offsetHeight;
		} else {
			active_slot = get_slot(n);
			indicator.innerHTML = '&#x25B6';
			active_slot.firstChild.make_active();
			indicator.style.left = _compound_offset_left(active_slot)-indicator.offsetWidth;
			indicator.style.top = _compound_offset_top(active_slot)+(active_slot.offsetHeight-indicator.offsetHeight)/2;
		}
		indicator.style.visibility = 'visible';
	}
}

function body_dblclick(e) {
	window.getSelection().removeAllRanges();
	slottop = _compound_offset_top(document.getElementById('slots'));
	if ( e.clientY < slottop )
		select_active(-1);
	else
		select_active(get_N());

}
document.addEventListener("dblclick", body_dblclick, false);
if (window["SyntaxHighlighter"] !== undefined)
  SyntaxHighlighter.all();
