function add_presentation_video_object(id, filename, n) {
  return add_video_object(id, filename, n);
}
function add_presentation_image_object(id, filename, n) {
  return add_image_object(id, filename, n);
}
function update()
{
    MathJax.Hub.Queue(["Typeset", MathJax.Hub]);
    if (window["SyntaxHighlighter"] !== undefined)
      SyntaxHighlighter.highlight();
}
function append_js(js)
{
        var script = document.createElement('script');
	script.type = 'text/javascript';

	script.appendChild(document.createTextNode(js));

	document.body.appendChild(script);
}

function append_slot_unloader(s, n, js)
{
	total_js = 'function slot_unloader_'+s+'_'+n+'() { var n='+n+'; '+js+'}';
	append_js(total_js);
}

function append_slot_loader(s, n, js)
{
	total_js = 'function slot_loader_'+s+'_'+n+'() { var n='+n+'; '+js+'}';
	append_js(total_js);
}

function add_svg(variant, svg, body_left, body_top, body_width, body_height, body_style) {
	variant_svg = document.getElementById('variant_'+variant);
	if ( variant_svg === null) {
		variant_svg = document.createElement('div');
		variant_svg.id = 'variant_'+variant;
		document.body.appendChild(variant_svg);
	}
	variant_svg.className = 'variant_svg';
	variant_svg.innerHTML = svg;
        variant_svg.style.cssText = body_style;
	variant_svg.style.top    = body_top;//-document.getElementById('background').height;
	variant_svg.style.left   = body_left;
	variant_svg.style.width  = body_width;
	variant_svg.style.height = body_height;
}
current_variant = null;
function set_svg(variant) {
	if ( variant == current_variant )
		return

	svg = document.getElementById('background');
	variant_svg = document.getElementById('variant_'+variant);

	fg = document.getElementById('foreground');
        document.getElementById('slots').style.cssText = variant_svg.style.cssText;
	fg.style.top = variant_svg.style.top;//-document.getElementById('background').height;
	fg.style.left = variant_svg.style.left;
	fg.style.width = variant_svg.style.width;
	fg.style.height = variant_svg.style.height;

        /* Work around known WebKit bug: 79586 */
        variant_svg = variant_svg.innerHTML;
        variant_svg = variant_svg.replace(/ xlink=/gi, ' xmlns:xlink=');
        variant_svg = variant_svg.replace(/ href=/gi, ' xlink:href=');
	svg.innerHTML = variant_svg;

}

function text_to_title(id) {
        el = document.getElementById(id);

	text = '';
	if (el !== null)
	   text = el.childNodes[0].data;
	else 
	   text = "{NULL}";
	document.title = text;
}

function get_value(id) {
        el = document.getElementById(id);

	text = '';
	if (el !== null)
	   text = el.value;
	else 
	   text = "{NULL}";
	document.title = text;
}

function remove_by_id(id) {
	obj = document.getElementById(id);
	if (obj !== null)
		obj.parentNode.removeChild(obj);
}

function add_presentation_svg_object(id, n) {
	var tv = add_svg_object(id, n);
}

function add_presentation_codeview(id, n) {
	var tv = add_codeview(id, n);
}

function add_presentation_textview(id, n) {
	var tv = add_textview(id, n);
}

function _compound_offset_left(obj) {
	if (!obj)
		return 0;
	return obj.offsetLeft + _compound_offset_left(obj.offsetParent);
}

function _compound_offset_top(obj) {
	if (!obj)
		return 0;
	return obj.offsetTop + _compound_offset_top(obj.offsetParent);
}

function init_presentation() {
}

function set_details() {
	window['set_details_'+get_slide_number()]();
}
function init_slide() {
	set_svg(get_slide_variant());
	set_details();
	load_slots();
	enter_spronk(0);
}

function get_spronk_count() {
	return window['get_'+get_slide_number()+'_spronk_count']();
}
function enter_spronk(spronk) {
	window['enter_'+get_slide_number()+'_spronk'](spronk);
}

function leave_spronk(spronk) {
	window['leave_'+get_slide_number()+'_spronk'](spronk);
}

kc_pgup = 33
kc_pgdown = 34
kc_end = 35
kc_home = 36
kc_left = 37
kc_up = 38
kc_right = 39
kc_down = 40
kc_enter = 13 // ==return also
function handle_keyup(e) {
  if (e.keyCode == kc_enter && e.ctrlKey) {
	  enter_spronk('overview');
  }
  if (e.keyCode == kc_left) {
	  go_previous();
  }
  if (e.keyCode == kc_right) {
	  go_next();
  }
  if (e.keyCode == kc_end) {
	  slide_change(get_slide_total()-1);
  }
  if (e.keyCode == kc_home) {
	  slide_change(0);
  }
}

function go_previous() {
	if ( current_spronk == null )
		enter_spronk(0);
	else if ( current_spronk == 0 )
		go_previous_slide();
	else
		enter_spronk(current_spronk-1);
}

function go_next() {
	if ( current_spronk == null )
		enter_spronk(0);
	else if ( current_spronk+1 >= get_spronk_count() )
		go_next_slide();
	else
		enter_spronk(current_spronk+1);
}

function go_previous_slide() {
	if (get_slide_number()>0)
		slide_change(get_slide_number()-1);
}
function go_next_slide() {
	if (get_slide_number()+1 < get_slide_total())
		slide_change(get_slide_number()+1);
}
function slide_change(to_slide) {
	if ( get_slide_change_method == null )
		alert('Do not know how to get to another slide');
	if ( get_slide_change_method() == 'external' )
		document.location = 'slide_'+to_slide+'.html';
	if ( get_slide_change_method() == 'notify' )
		document.location = 'lantern:slide-change:'+to_slide;
	if ( get_slide_change_method() == 'internal' ) {
		leave_spronk(current_spronk);
		unload_slots();
		slide_num = to_slide;
		current_spronk = null;
		init_slide();
	}
}
function load_slots() {
	for (i=0; i<get_N(); i++)
	{
		window['slot_loader_'+get_slide_number()+'_'+i]();
	}
}
function unload_slots() {
	for (i=0; i<get_N(); i++)
	{
		window['slot_unloader_'+get_slide_number()+'_'+i]();
	}
}

document.addEventListener("keyup", handle_keyup, true);
if (window["SyntaxHighlighter"] !== undefined)
  SyntaxHighlighter.all();
