import aesthete.paths as paths
paths.setup("aesthete")

import os
import subprocess
import argparse
import lxml.etree as ET
from aesthete import details
from xml.parsers.expat import ExpatError

argparser = argparse.ArgumentParser()
argparser.add_argument('-c', '--aesthete-command')
args = argparser.parse_args()

if args.aesthete_command is not None :
    aesthete_command = args.aesthete_command
else :
    aesthete_command = details.get_command()

phrasegroups = os.listdir('../share/defs')
for u in phrasegroups :
    try :
        filename = "../share/defs/%s"%u
        tree = ET.parse(filename)
        name = tree.getroot().tag.lower()
        print '\t%s : %s' % (name, u)

        tmp_filename = "/tmp/aes_make_ref_svg.xml"
        f = open(tmp_filename, 'w')
        f.write('<phrasegroup type="%s"/>' % name)
        f.close()

        aes_instance = subprocess.call([aesthete_command, "-n",
                                        "-f", tmp_filename,
                                        "-o", "reference/aesthete-phrasegroup-%s.svg"%name])

    except (ExpatError, ET.XMLSyntaxError) as e :
        print "WARNING : Could not parse PG '%s', continuing without: %s" % (u, e)

